import { Container } from "../../Core/Container";
import { ICoordinates } from "../../Core/Interfaces/ICoordinates";
import { IEmitter } from "./Options/Interfaces/IEmitter";
import { Emitters } from "./Emitters";
import { IEmitterSize } from "./Options/Interfaces/IEmitterSize";
import { IDelta } from "../../Core/Interfaces/IDelta";
import { IHsl } from "../../Core/Interfaces/Colors";
export declare class EmitterInstance {
    private readonly emitters;
    private readonly container;
    position: ICoordinates;
    size: IEmitterSize;
    emitterOptions: IEmitter;
    spawnColor?: IHsl;
    readonly name?: string;
    private paused;
    private currentEmitDelay;
    private currentSpawnDelay;
    private currentDuration;
    private lifeCount;
    private firstSpawn;
    private duration?;
    private emitDelay?;
    private spawnDelay?;
    private readonly immortal;
    private readonly initialPosition?;
    private readonly particlesOptions;
    constructor(emitters: Emitters, container: Container, emitterOptions: IEmitter, position?: ICoordinates);
    externalPlay(): void;
    externalPause(): void;
    play(): void;
    pause(): void;
    resize(): void;
    update(delta: IDelta): void;
    private prepareToDie;
    private destroy;
    private calcPosition;
    private emit;
    private setColorAnimation;
}
